package eu.clarin.cmdi.oai.harvester;

import java.util.Date;
import java.util.List;

public interface HarvestJob {
    public enum State {
        NEW,
        RUNNING,
        DONE,
        ERROR,
        CANCELED
    };

    public String getId();

    public State getState();

    public long getRecordCount();

    public long getRequestCount();

    public long getResumptionCount();

    public long getBytesTransferred();

    public long getTotalTime();

    public long getNetworkTime();

    public long getWaitTime();

    public long getProcessingTime();

    public HarvestHandler getHarvestHandler();

    public void setHarvestHandler(HarvestHandler handler);

    public Date getFrom();
    
    public void setFrom(Date from);
    
    public Date getUntil();
    
    public void setUntil(Date until);

    public String getSet();
    
    public void setSet(String set);

    public List<String> getMetadataPrefixes();
    
    public void setMetadataPrefixes(List<String> prefixes);

    public void run() throws HarvesterException;

    public void cancel() throws HarvesterException;

} // interface HarvestJob
