package eu.clarin.cmdi.oai.harvester;

public class ProtocolError {
    public enum Code {
        CANNOT_DISSERMINATE_FORMAT,
        ID_DOES_NOR_EXIST,
        BAD_ARGUMENT,
        BAD_VERB,
        NO_METADATA_FORMATS,
        NO_RECORDS_MATCH,
        BAD_RESUMPTION_TOKEN,
        NO_SET_HIERARCHY,
        INVALID_ERROR_CODE;

        public static Code fromString(String s) {
            if ("cannotDisseminateFormat".equals(s)) {
               return CANNOT_DISSERMINATE_FORMAT;
            } else if ("idDoesNotExist".equals(s)) {
                return ID_DOES_NOR_EXIST;
            } else if ("badArgument".equals(s)) {
                return BAD_ARGUMENT;
            } else if ("badVerb".equals(s)) {
                return BAD_VERB;
            } else if ("noMetadataFormats".equals(s)) {
                return NO_METADATA_FORMATS;
            } else if ("noRecordsMatch".equals(s)) {
                return NO_RECORDS_MATCH;
            } else if ("badResumptionToken".equals(s)) {
                return BAD_RESUMPTION_TOKEN;
            } else if ("noSetHierarchy".equals(s)) {
                return NO_SET_HIERARCHY;
            } else {
                return INVALID_ERROR_CODE;
            }
        }
    }

    private final Code code;
    private final String message;
    
    public ProtocolError(String code, String message) {
        this.code = Code.fromString(code);
        this.message = message;
    }

    public Code getCode() {
        return code;
    }
    
    public String getMessage() {
        return message;
    }

    public String toString() {
        return code + ": " + message;
    }

} // class ProtocolError
